package io.nisum.spark.producer;

import org.apache.spark.sql.*;

public class KafkaMessageProducer {
    public static void main(String[] args) {

        SparkSession spark = SparkSession.builder()
                .master("local[*]")
                .appName("Produce CSV Product Info to Kafka Topic")
                .getOrCreate();

        Dataset<Row> productInfo = spark.read()
                                    .format("csv")
                                    .option("header", true)
                                    .option("multiline", "true")
                                    .csv("src/data/product-info.csv");

        productInfo.printSchema();
        productInfo.show();

        productInfo
                .selectExpr( "cast(productId as string) as key", "to_json(struct(*)) as value")
                .write()
                .option("kafka.bootstrap.servers", "127.0.0.1:9092")
                .option("topic", "product-csv-topic-1")
                .option("header", true)
                .format("kafka")
                .save();

    }
}
